-- Syrečky pro Hagen engine
-- (c) Severák 2019

-- / port z ALAN verze

title = "Syrečky (technologické demo)"

-- utils

local function randomp(texty)
	return function()
		p(texty[math.random(1, #texty)])
	end
end

-- slovesa

cont=verb{
	n="pokračovat",
	act = function()
		walk(game[here()].cont)
	end
}

sever = verb{
	n = "sever",
	act = function()  walk(game[me.w]['sever']) end
}

jih = verb{
	n = "jih",
	act = function()  walk(game[me.w]['jih']) end
}

desc = verb{
	n ="prozkoumej",
	params = {"desc"},
	act = function(what)
		--print("zkoumam " .. what)
		local description = game[what].desc
		if type(description)=='string' then
			p(description)
		end
		
		if type(description)=='function' then
			description()
		end
	end
}

open = verb{
	n ="otevři",
	params = {"open"},
	act = function(what)
		local description = game[what].open
		if type(description)=='string' then
			p(description)
		end
		
		if type(description)=='function' then
			description()
		end
	end
}

give  = verb{
	n = "dej",
	params = {"syrecky"},
	act = function()
		-- tohle je trošku hack
		if here()=="obyvak" then
			p "Dokázal jsi to! Dal jsi otci syrečky."
			p "Game over!"
		else
			p "Není tu nikdo, komu bys syrečky dal."
		end
	end
}

-- předměty a lokace

-- OBÝVÁK

obyvak = room{
	n="Obývák",
	d="Normalní panelakový obývak. Na sever od něj je kuchyně.",
	sever="kuchyn"
}

maska = item{
	n="masku",
	d="Plynova maska z dob ruske okupace.",
	desc="Stará protiplynová maska, patrně ruské výroby. Nechápu co dělala v pohovce.",
	w="pohovka"
}

pohovka = item{
	n="pohovku",
	d="Stará prašivá pohovka sotva drží. Pamatuje snad i druhou světovou.",
	desc = function()
		if maska.w=='pohovka' then
			p "Z pohovky čouhá něco divného, zkusím to vytáhnout."
			p "Wow! Je to plynová maska!"
			move("maska", "me")
		else
			p "V pohovce je už jenom prach."
		end
	end,
	w="obyvak"
}

otec = item{
	n="otce",
	d="Na pohovce se valí otec a kouka se na bednu.",
	desc="Tvůj fotr. Fešák.",
	w="obyvak"
}

televize = item{
	n = "televizi",
	desc = randomp{"V telce běží zápas pražských S.", "Fanoušci v televizi hážou dělobuchy.", "Právě běží reklama.", "V televizi je Horst Fuchs: A když zavoláte do deseti minut, dostanete ke každému noži koťátko zdarma."},
	w = "obyvak"
}


-- KUCHYNĚ

kuchyn = room{
	n="Kuchyň",
	d="Umakartová kuchyň z doby vrcholného komunismu. Na jih od ní je obyvák.",
	jih="obyvak"
}

syrecky = item{
	n = "syrečky",
	desc = "Strašně smradlavé syrečky.",
	w = "lednice",
	syrecky = true
}

lednice = item{
	n="lednici",
	d="Spořádaně tu vrní obstarožní lednice",
	desc = "Obstarožní lednička značky CALEX. Hotová hrozba pro životní prostředí.",
	open = function()
		p "Otevíráš ledničku. Dveře vržou."
		if syrecky.w=="lednice" then
			if maska.w=="me" then
				p "Syrečky strašne smrdí, bereš si na pomoc plynovou masku."
				move("syrecky", "me")
				p "Vypadáš přitom jak stalker ze stejnojmené počitačové hry, ale podařilo se ti vzít syrečky."
			else
				p "Strašlivý smrad syrečků tě donutil ledničku zase zavřít!"
			end
		else
			p "V lednici však už je jen \"Příšera, která žila v lednici vedle majonézy a za zelným salátem\". A to tě nezajímá."
		end
	end,
	w="kuchyn"
}

vyhled = item{
	n = "výhled",
	d = "A je tu krásný výhled na Jihozápadní město",
	w="kuchyn",
	desc = randomp{
		"Paneláky dnes vypadají patřičně depresivně.",
		"Před barákem zrovna někomu kradou auto.",
		"Před barákem zrovna policajti rozdávají pokuty.",
		"Děti si hrajou na hřišti.",
		"Důchodkyně pomlouvají tu dnešní mládež.",
	},
	open="Okno raději otvírat nebudu, mohl by se sem dostat smog."
}

-- META

local sledovani = randomp{
	"Otec se napil piva.",
	"GOOOOOOOOOOOOOOOL!!!!\n",
	"Otec se raduje, Sparta vede 1:0 .",
	"Otec začína být nervózní.\nOtec: Tak kde jsou sakra ty syrečky?!"
}

local zrani = randomp{
	"Otec spokojeně mlaská při žraní syrečků.",
	"Otec: To je dobrota, to je dobrota.",
	"Otec: Mňam, mňam..."
}

function round()
	if here()=="obyvak"  then
		if syrecky.w=="otec" then
			zrani()
		else	
			sledovani()
		end
	end
end


intro = room{
	d=[[SYREČKY - technologické demo

Tvým cílem je donést otci syrečky z kuchyně.

Hru navrhnul Petr Kain v roce 2010, potom sloužila jako česká obdoba Cloak of Darkness.]],
	cont="obyvak"
}